import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.io.InputStream;
import java.net.URL;

public class ClientSearchGenerator {
   // $FF: renamed from: g SearchEngineGenerator
   static SearchEngineGenerator field_0;
   static boolean zipAvailable;

   static void usage() {
      System.out.println("Gueltige Argumente:");
      System.out.println("  CLEAR                     Suchindex loeschen");
      System.out.println("  ADD    home file [url]    Datei indizieren");
      System.out.println("  ADDW   home file          Mehrere Dateien indiziern (mit Wildcards)");
      System.out.println("  ADDWS  home file          Mehrere Dateien indiziern (mit Wildcards ");
      System.out.println("                            und Unterverzeichnissen)");
      System.out.println("  SPIDER home file          Dokument und alle Verweise indizieren");
      System.exit(1);
   }

   static void load() {
      System.out.println("Lade searchR.dat");

      try {
         FileInputStream var0 = new FileInputStream("searchR.dat");
         field_0.load(var0);
         ((InputStream)var0).close();
      } catch (Exception var1) {
         System.err.println("Exception: " + ((Throwable)var1).getMessage());
      }

      System.out.println(field_0.getStatus());
   }

   static void save() {
      try {
         System.out.println("Speichere searchR.dat");
         field_0.save(new FileOutputStream("searchR.dat"));
      } catch (Exception var2) {
         System.err.println("Exception: " + ((Throwable)var2).getMessage());
      }

      if (zipAvailable) {
         try {
            System.out.println("Speichere searchZ.dat");
            field_0.saveZIP(new FileOutputStream("searchZ.dat"));
         } catch (Exception var1) {
            System.err.println("Exception: " + ((Throwable)var1).getMessage());
         }
      } else {
         System.err.println("WARNUNG: ZIP-Kompression nicht verfuegbar. searchZ.dat wurde nicht erzeugt.");
      }

      System.out.println(field_0.getStatus());
   }

   static void addDir(File var0, String var1, FilenameFilter var2, boolean var3) {
      System.out.println("Durchsuche " + var0.toString());
      String[] var4 = var0.list(var2);
      if (var4 != null) {
         for(int var5 = 0; var5 < var4.length; ++var5) {
            System.out.println("Indiziere " + var1 + var4[var5]);

            try {
               File var6 = new File(var0, var4[var5]);
               FileInputStream var7 = new FileInputStream(var6);
               DocumentParser var8 = new DocumentParser(field_0, var7);
               var8.parse(var1 + var4[var5]);
            } catch (Exception var9) {
               System.err.println("Exception: " + ((Throwable)var9).getMessage());
            }
         }
      }

      if (var3) {
         var4 = var0.list();
         if (var4 != null) {
            for(int var11 = 0; var11 < var4.length; ++var11) {
               File var12 = new File(var0, var4[var11]);
               if (var12.isDirectory()) {
                  addDir(var12, var1 + var4[var11] + File.separator, var2, var3);
               }
            }
         }
      }

   }

   public static void main(String[] var0) {
      if (var0.length < 1) {
         usage();
      }

      field_0 = new SearchEngineGenerator();

      try {
         Class.forName("java.util.zip.InflaterInputStream");
         Class.forName("java.util.zip.DeflaterOutputStream");
         zipAvailable = true;
      } catch (Exception var6) {
      }

      if (var0[0].equalsIgnoreCase("CLEAR")) {
         save();
      } else if (!var0[0].equalsIgnoreCase("ADD")) {
         if (!var0[0].equalsIgnoreCase("ADDW") && !var0[0].equalsIgnoreCase("ADDWS")) {
            if (var0[0].equalsIgnoreCase("SPIDER")) {
               if (var0.length != 3) {
                  usage();
               }

               load();

               try {
                  URL var8 = new URL(var0[1]);
                  SearchEngineSpider var9 = new SearchEngineSpider(var8, var0[2]);
                  var9.run(field_0);
               } catch (Exception var5) {
                  System.err.println("Exception: " + ((Throwable)var5).getMessage());
               }

               save();
            } else {
               usage();
            }
         } else {
            boolean var7 = var0[0].equalsIgnoreCase("ADDWS");
            if (var0.length != 3) {
               usage();
            }

            load();
            addDir(new File(var0[1]), new String(""), new WildcardFilter(var0[2]), var7);
            save();
         }
      } else {
         if (var0.length < 3 || var0.length > 4) {
            usage();
         }

         load();

         try {
            URL var1 = new URL(var0[1]);
            URL var2 = new URL(var1, var0[2]);
            System.out.println("Indiziere " + var2.toString());
            DocumentParser var3 = new DocumentParser(field_0, var2.openStream());
            var3.parse(var0.length >= 4 ? var0[3] : var0[2]);
         } catch (Exception var4) {
            System.err.println("Exception: " + ((Throwable)var4).getMessage());
         }

         save();
      }
   }
}
