import java.io.File;
import java.io.FilenameFilter;

class WildcardFilter implements FilenameFilter {
   String wildcard;

   WildcardFilter(String var1) {
      this.wildcard = var1;
   }

   public boolean accept(File var1, String var2) {
      return this.match(var2, 0, 0);
   }

   boolean match(String var1, int var2, int var3) {
      while(true) {
         if (var2 < var1.length() && var3 < this.wildcard.length()) {
            if (this.wildcard.charAt(var3) == '?') {
               if (var1.charAt(var2++) == '.') {
                  return false;
               }

               ++var3;
               continue;
            }

            if (this.wildcard.charAt(var3) != '*') {
               if (var1.charAt(var2++) == this.wildcard.charAt(var3++)) {
                  continue;
               }

               return false;
            }

            while(var2 <= var1.length()) {
               if (this.match(var1, var2++, var3 + 1)) {
                  return true;
               }
            }

            return false;
         }

         while(var3 < this.wildcard.length() && this.wildcard.charAt(var3) == '*') {
            ++var3;
         }

         if (var2 == var1.length() && var3 == this.wildcard.length()) {
            return true;
         }

         return false;
      }
   }
}
